//------------------------------------------------------------------//
//     MTRADER ( 3.25)    //
//., 2009 .,  ..                                    //
//------------------------------------------------------------------//

#ifndef _MTRADER_H
#define _MTRADER_H

#define EXPORT extern "C" __declspec (dllexport)

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <io.h>
#include <dir.h>
#include <time.h>
#pragma pack(8)

//---------------------------------------------------------------------------
// 
struct KotInfo
  {
   TDateTime      ctm;            //  
   double         open;           //  
   double         low;            //  low
   double         high;           //  high
   double         close;          //  
   int            vol;            // 
  };
//---------------------------------------------------------------------------
//  
struct OperInfo
  {
   TDateTime      start;          //   
   TDateTime      finish;         //      
   bool           work;           //   
   double         open;           //  
   double         close;          //  
   int            vol;            //  
   int            tip;            //    (1-Buy, 2-Sell)
   int            spred;          //     
   double         punkt;          //  1 
  };
//---------------------------------------------------------------------------
//  
struct MTSInfo
  {
   double         year;           //  
   int            oper;           //   
   int            buy;            //  BUY
   int            buy_up;         //  BUY   
   int            buy_dn;         //  BUY
   double         buy_dox;        //   BUY   
   int            sell;           //  SELL
   int            sell_up;        //  SELL 
   int            sell_dn;        //  SELL
   double         sell_dox;       //   SELL
   double         all_dox;        //    
   double         profit;         // Profit-
   double         max_dn;         // .
   int            max_oper_dn;    //    
   double         up;             //  
   double         down;           //  
   double         sharp;          // .
   double         Z;              // Z-
   double         Prom;           // PROM
   double         t;              //  
   double         p;              //   
  };
//---------------------------------------------------------------------------
//  
EXPORT int CALLBACK Indikator(int fun, double *vix, long kvo, KotInfo *xxx);   //   fun
EXPORT long CALLBACK HistoryKotCSV(char *file, int des, KotInfo *xxx);         //  CSV  
EXPORT long CALLBACK HistoryKotPRN(char *file, int des, KotInfo *xxx);         //  PRN  
EXPORT long CALLBACK Identif();                                          //  
EXPORT double CALLBACK Okrug(double vxod, int des);                            //
EXPORT void CALLBACK ToExcel(double **xxx, int Height, int Width);             //  Excel
EXPORT AnsiString CALLBACK KotSlesh(AnsiString gg);                            //    
EXPORT AnsiString CALLBACK KotNoSlesh(AnsiString gg);                          //    
EXPORT void CALLBACK Protokol(char *ttt);                                      //    Protokol.dat
EXPORT void CALLBACK KachestvoMTS(OperInfo *oper, int vse, MTSInfo *info);     //  
EXPORT int CALLBACK Srednee(double *vix, long kvo, KotInfo *xxx, int per);     //    per
EXPORT int CALLBACK SredneeX(double *vix, long kvo, KotInfo *xxx, int per);    //    per
EXPORT int CALLBACK SredneeW(double *vix, long kvo, KotInfo *xxx, int per);    //    per
EXPORT int CALLBACK AvgDirMov(double *vix, long kvo, KotInfo *xxx, int per);   //C     per
EXPORT int CALLBACK StochOsc(double *vix, long kvo, KotInfo *xxx, int per1, int per2);  // % ( per1  per2)
EXPORT int CALLBACK Momentum(double *vix, long kvo, KotInfo *xxx, int per);    //   per
EXPORT int CALLBACK RSI(double *vix, long kvo, KotInfo *xxx, int per);         //RSI   per
EXPORT int CALLBACK Parabolic(double *vix, long kvo, KotInfo *xxx, int per);   //   per
EXPORT int CALLBACK MACD(double *vix, long kvo, KotInfo *xxx, int per1, int per2);   //MACD ( per1  per2)
EXPORT int CALLBACK KAMA(double *vix, long kvo, KotInfo *xxx);                 //KAMA (Kaufman Adaptive Moving Average)
EXPORT int CALLBACK MAMA(double *vix, long kvo, KotInfo *xxx);                 //MAMA (MESA Adaptive Moving Average)
EXPORT int CALLBACK Trend(double *vix, long kvo, KotInfo *xxx, int per);       //    per
EXPORT int CALLBACK Osnovn(double *vix, long kvo,KotInfo *xxx);                // 
EXPORT int CALLBACK CCI(double *vix, long kvo, KotInfo *xxx, int per1, int per2);  //CCI -    ( per1  per2)
EXPORT int CALLBACK PCR(double *vix, long kvo, KotInfo *xxx, int per);         //    per
EXPORT int CALLBACK Svecha(double *vix, long kvo, KotInfo *xxx, int fun);      //  fun=1..23 
EXPORT int CALLBACK DMI(double *vix, long kvo, KotInfo *xxx, int per);         //   - DMI
EXPORT int CALLBACK TrendMode(double *vix, long kvo, KotInfo *xxx);            //,    
EXPORT int CALLBACK JMA(double *vix, long kvo, KotInfo *xxx, int per, int faza);   //Jurik Moving Average (per-, faza-)
EXPORT int CALLBACK WILL(double *vix, long kvo, KotInfo *xxx);                 //%R 
EXPORT int CALLBACK WSO(double *vix, long kvo, KotInfo *xxx);                  //  
EXPORT int CALLBACK ARoondMax(double *vix, long kvo, KotInfo *xxx, int per);   // Aroon (.)
EXPORT int CALLBACK ARoondMin(double *vix, long kvo, KotInfo *xxx, int per);   // Aroon (.)
EXPORT int CALLBACK Keltner(double *vix, long kvo, KotInfo *xxx, int per);     //  
EXPORT int CALLBACK Ultima(double *vix, long kvo, KotInfo *xxx);               // Ultima
EXPORT int CALLBACK WCLPrice(double *vix, long kvo, KotInfo *xxx);             //Weighted Close Price
EXPORT int CALLBACK WPR(double *vix, long kvo, KotInfo *xxx);                  //Williams Percent Range
EXPORT int CALLBACK DX(double *vix, long kvo, KotInfo *xxx);                   //Directional Movement Index
EXPORT int CALLBACK SAR(double *vix, long kvo, KotInfo *xxx);                  //Parabolic SAR
EXPORT int CALLBACK Regress(double *vix, long kvo, KotInfo *xxx);              //  
EXPORT int CALLBACK ADX(double *vix, long kvo, KotInfo *xxx);                  //Average Directional Movement Index
EXPORT int CALLBACK TSF(double *vix, long kvo, KotInfo *xxx);                  //Time Series Forecast
EXPORT int CALLBACK Rasmax(double *vix, long kvo, KotInfo *xxx);               // 
EXPORT int CALLBACK TypPrice(double *vix, long kvo, KotInfo *xxx);             // 
EXPORT int CALLBACK CG(double *vix, long kvo, KotInfo *xxx, int per);          //  -1
EXPORT int CALLBACK CGO(double *vix, long kvo, KotInfo *xxx, int per);         //  -2
EXPORT int CALLBACK PlusDM(double *vix, long kvo, KotInfo *xxx, int per);      //Plus Directional Movement
EXPORT int CALLBACK MinusDM(double *vix, long kvo, KotInfo *xxx, int per);     //Minus Directional Movement
EXPORT int CALLBACK Fractal(double *vix, long kvo, KotInfo *xxx);              //  
EXPORT int CALLBACK TrendTrigger(double *vix, long kvo, KotInfo *xxx);         //  TrendTrigger
EXPORT int CALLBACK Murash(double *vix, long kvo, KotInfo *xxx);               // Murash
EXPORT int CALLBACK ASCTrend(double *vix, long kvo, KotInfo *xxx, int per);    // ASCTrend c  per
EXPORT int CALLBACK BrainTrend1(double *vix, long kvo, KotInfo *xxx);          // BrainTrend1
EXPORT int CALLBACK BrainTrend2(double *vix, long kvo, KotInfo *xxx);          // BrainTrend2
EXPORT int CALLBACK Prognoz(double *vix, long kvo, KotInfo *xxx, int per);     //     per
EXPORT int CALLBACK UgolLog(double *vix, long kvo, KotInfo *xxx);              //  
EXPORT int CALLBACK Mediana(double *vix, long kvo, KotInfo *xxx, int per);     //   per
EXPORT int CALLBACK FishTrans(double *vix, long kvo, KotInfo *xxx, int per);   // FishTrans c  per
EXPORT int CALLBACK TSI(double *vix, long kvo, KotInfo *xxx, int per1, int per2);  // True Strength Index c  per1  per2
EXPORT int CALLBACK Volatil(double *vix, long kvo, KotInfo *xxx, int per);     //   per

#endif
//---------------------------------------------------------------------------

